"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.localValue = exports.invalid = exports.valid = exports.absent = exports.isInvalid = exports.isValid = exports.isAbsent = exports.alt = exports.toEither = exports.toOption = exports.fromEither = exports.fromOption = exports.map = exports.chain = exports.of = exports.getOrElse = exports.fold2 = exports.fold = exports.URI = void 0;
var O = __importStar(require("fp-ts/Option"));
var E = __importStar(require("fp-ts/Either"));
var pipeable_1 = require("fp-ts/pipeable");
exports.URI = "LocalValue";
// -------------------------------------------------------------------------------------
// non-pipeables
// -------------------------------------------------------------------------------------
var _map = function (lv, f) {
    if (exports.isAbsent(lv) || exports.isInvalid(lv)) {
        return lv;
    }
    return exports.valid(f(lv.value));
};
var _ap = function (apLocalValue, lv) {
    return _chain(apLocalValue, function (f) { return _map(lv, function (a) { return f(a); }); });
};
var _chain = function (lv, f) {
    if (exports.isAbsent(lv) || exports.isInvalid(lv)) {
        return lv;
    }
    return f(lv.value);
};
var _zero = function () { return exports.absent; };
var _alt = function (lv, la) {
    if (exports.isAbsent(lv) || exports.isInvalid(lv)) {
        return lv;
    }
    return la();
};
var _reduce = function (fa, b, f) {
    return exports.fold(function () { return b; }, function () { return b; }, function (a) { return f(b, a); })(fa);
};
var _foldMap = function (M) { return function (fa, f) {
    return exports.fold(function () { return M.empty; }, function () { return M.empty; }, function (a) { return f(a); })(fa);
}; };
var _reduceRight = function (fa, b, f) {
    return exports.fold(function () { return b; }, function () { return b; }, function (a) { return f(a, b); })(fa);
};
// -------------------------------------------------------------------------------------
// pipeables
// -------------------------------------------------------------------------------------
var fold = function (onNone, onError, onValue) { return function (fa) {
    if (exports.isAbsent(fa)) {
        return onNone();
    }
    if (exports.isInvalid(fa)) {
        return onError(fa.errors);
    }
    return onValue(fa.value);
}; };
exports.fold = fold;
var fold2 = function (onNone, onValue) { return function (fa) {
    if (exports.isAbsent(fa) || exports.isInvalid(fa)) {
        return onNone();
    }
    return onValue(fa.value);
}; };
exports.fold2 = fold2;
var getOrElse = function (defaultValue) { return function (lv) {
    if (exports.isAbsent(lv) || exports.isInvalid(lv)) {
        return defaultValue();
    }
    return lv.value;
}; };
exports.getOrElse = getOrElse;
var of = function (v) { return exports.valid(v); };
exports.of = of;
var chain = function (f) { return function (lv) {
    return _chain(lv, f);
}; };
exports.chain = chain;
var map = function (f) { return function (lv) {
    return _map(lv, f);
}; };
exports.map = map;
var fromOption = function (o) {
    return pipeable_1.pipe(o, O.fold(function () { return exports.absent; }, function (v) { return exports.valid(v); }));
};
exports.fromOption = fromOption;
var fromEither = function (e) {
    return pipeable_1.pipe(e, E.fold(exports.invalid, function (v) { return exports.valid(v); }));
};
exports.fromEither = fromEither;
var toOption = function (v) {
    return pipeable_1.pipe(v, exports.fold(function () { return O.none; }, function () { return O.none; }, function (v) { return O.some(v); }));
};
exports.toOption = toOption;
var toEither = function (onNone) { return function (v) {
    return pipeable_1.pipe(v, exports.fold(function () { return E.left(onNone()); }, E.left, E.right));
}; };
exports.toEither = toEither;
var alt = function (la) { return function (lv) {
    return _alt(lv, la);
}; };
exports.alt = alt;
var isAbsent = function (lv) {
    return lv._tag === "Absent";
};
exports.isAbsent = isAbsent;
var isValid = function (lv) {
    return lv._tag === "Valid";
};
exports.isValid = isValid;
var isInvalid = function (lv) {
    return lv._tag === "Invalid";
};
exports.isInvalid = isInvalid;
exports.absent = {
    _tag: "Absent",
};
var valid = function (v) {
    return { _tag: "Valid", value: v };
};
exports.valid = valid;
var invalid = function (e) {
    return { _tag: "Invalid", errors: e };
};
exports.invalid = invalid;
exports.localValue = {
    URI: exports.URI,
    map: _map,
    chain: _chain,
    getOrElse: exports.getOrElse,
    of: exports.of,
    ap: _ap,
    zero: _zero,
    alt: _alt,
    reduce: _reduce,
    reduceRight: _reduceRight,
    foldMap: _foldMap,
};
