import { Codec, decodeType, runtimeType } from "./Codec";
import { Absent, LocalValue, Valid } from "./LocalValue";
declare type ValidCodec = Codec<any, string, any>;
declare type ValidLocalValue<A> = Absent | Valid<A>;
interface UseLocalItemOptions<C extends ValidCodec> {
    useMemorySore?: boolean;
    defaultValue?: runtimeType<C>;
}
export declare const getLocalElement: <E, A, O extends UseLocalItemOptions<any>>(t: string, codec: Codec<E, string, A>, options?: O | undefined) => LocalValue<E, A>;
export declare const setLocalElement: <E, A, O extends UseLocalItemOptions<any>>(t: string, codec: Codec<E, string, A>, v: A, options?: O | undefined) => void;
export declare const removeLocalElement: <O extends UseLocalItemOptions<any>>(t: string, options?: O | undefined) => void;
export declare type LocalValueHook<C extends ValidCodec> = () => [
    item: decodeType<C>,
    setItem: (i: ValidLocalValue<runtimeType<C>>) => void
];
export declare const makeUseLocalItem: <C extends ValidCodec>(key: string, codec: C, options?: UseLocalItemOptions<C> | undefined) => LocalValueHook<C>;
export {};
