"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeUseLocalItem = exports.removeLocalElement = exports.setLocalElement = exports.getLocalElement = void 0;
var React = __importStar(require("react"));
var O = __importStar(require("fp-ts/Option"));
var function_1 = require("fp-ts/function");
var localStorageProxy_1 = require("./localStorageProxy");
var LV = __importStar(require("./LocalValue"));
var memoryStore = new localStorageProxy_1.MemoryStorageProxy();
var getStore = function (o) { var _a; return ((_a = o === null || o === void 0 ? void 0 : o.useMemorySore) !== null && _a !== void 0 ? _a : false) ? memoryStore : localStorageProxy_1.localStorageProxy; };
var getLocalElement = function (t, codec, options) {
    var store = getStore(options);
    return function_1.pipe(O.fromNullable(store.getItem(t)), LV.fromOption, LV.chain(function (v) { return codec.decode(v); }));
};
exports.getLocalElement = getLocalElement;
var setLocalElement = function (t, codec, v, options) {
    var store = getStore(options);
    store.setItem(t, codec.encode(v));
};
exports.setLocalElement = setLocalElement;
var removeLocalElement = function (t, options) {
    var store = getStore(options);
    store.removeItem(t);
};
exports.removeLocalElement = removeLocalElement;
var makeUseLocalItem = function (key, codec, options) {
    return (function () {
        var _a = React.useState(exports.getLocalElement(key, codec, options)), item = _a[0], setItem = _a[1];
        var setItemMemo = React.useMemo(function () {
            return function (i) {
                return function_1.pipe(i, LV.fold2(function () {
                    exports.removeLocalElement(key, options);
                    setItem(exports.getLocalElement(key, codec, options));
                }, function (newValue) {
                    exports.setLocalElement(key, codec, newValue, options);
                    setItem(exports.getLocalElement(key, codec, options));
                }));
            };
        }, [item]);
        var onLocalStorageChange = function (event) {
            if (localStorageProxy_1.isLocalStorageEvent(event)) {
                if (event.detail.key === key) {
                    setItem(exports.getLocalElement(key, codec, options));
                }
            }
            else {
                if (event.key === key) {
                    setItem(exports.getLocalElement(key, codec, options));
                }
            }
        };
        React.useEffect(function () {
            var listener = function (e) {
                onLocalStorageChange(e);
            };
            window.addEventListener(localStorageProxy_1.storeChangedCustomEvent, listener);
            // The storage event only works in the context of other documents (eg. other browser tabs)
            window.addEventListener("storage", listener);
            return function () {
                window.removeEventListener(localStorageProxy_1.storeChangedCustomEvent, listener);
                window.removeEventListener("storage", listener);
            };
        }, [key]);
        return [item, setItemMemo];
    });
};
exports.makeUseLocalItem = makeUseLocalItem;
